#include "main.h"

#include <png.h>

unsigned char *
png_load(const char *file, int *w, int *h)
{
   png_byte **lines, *pix = NULL;
   png_byte header[8];
   png_structp png_ptr;
   png_infop info_ptr;
//   png_byte color_type;
//   png_byte bit_depth;
//   int num_pass;
   int y;
   FILE *f = fopen(file, "rb");
   if (!f)
     {
        printf("Can't open PNG: %s\n", file);
        goto err1;
     }
   fread(header, 1, 8, f);
   if (png_sig_cmp(header, 0, 8))
     {
        printf("Not a PNG file: %s\n", file);
        goto err2;
     }
   png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
   info_ptr = png_create_info_struct(png_ptr);
   png_init_io(png_ptr, f);
   png_set_sig_bytes(png_ptr, 8);
   png_read_info(png_ptr, info_ptr);

   *w = png_get_image_width(png_ptr, info_ptr);
   *h = png_get_image_height(png_ptr, info_ptr);
//   color_type = png_get_color_type(png_ptr, info_ptr);
//   bit_depth = png_get_bit_depth(png_ptr, info_ptr);
//   num_pass = png_set_interlace_handling(png_ptr);
   png_read_update_info(png_ptr, info_ptr);

   if (png_get_valid(png_ptr, info_ptr, PNG_INFO_tRNS))
     {
        png_set_tRNS_to_alpha(png_ptr);
     }

   pix = malloc((*w) * (*h) * 4);
   if (!pix) goto err2;
   lines = malloc(sizeof(png_bytep) * (*h));
   for (y = 0; y < (*h); y++) lines[y] = pix + (y * (*w) * 4);
   png_read_image(png_ptr, lines);
   png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
   free(lines);
err2:
   fclose(f);
err1:
   return pix;
}
